<template>
  <div
    v-if="hasCountries"
    data-component="countries-menu"
  >
    <v-menu
      v-model="isOn"
      bottom
      offset-y
      content-class="countries-menu-content"
      transition="slide-y-transition"
      nudge-bottom="10"
      max-height="300"
      :close-on-click="true"
      :close-on-content-click="false"
    >
      <v-btn
        slot="activator"
        class="trigger select-item"
        :color="isOn ? 'primary' : 'secondary'"
        dark
        small
        :class="getTriggerClass()"
        @keydown="updateFilter"
        @click="toggle()"
      >
        {{ selectedCountry.name }}
        <v-icon
          v-if="hasMoreThanOneCountry"
          class="icon-chevron"
        >
          keyboard_arrow_down
        </v-icon>
      </v-btn>
      <v-list>
        <v-list-tile
          v-for="country in countries"
          :key="country.name"
          :value="country"
          color="secondary"
          :class="getItemClass(country)"
          @click="setCountry(country)"
        >
          <v-list-tile-title>
            {{ country.name }}
          </v-list-tile-title>
          <v-icon>
            settings
          </v-icon>
        </v-list-tile>
      </v-list>
    </v-menu>
  </div>
</template>

<script>
  export default {
    data() {
      return {
        countries: [],
        allCountries: [],
        filter: '',
        isOn: false
      };
    },
    computed: {
      userCountries() {
        return this.$store.getters['users/countries'];
      },
      hasCountries() {
        return this.$store.getters['users/countries'].length > 0;
      },
      hasMoreThanOneCountry() {
        return this.countries.length > 1;
      },
      selectedCountry() {
        return this.$store.getters['config/country'];
      }
    },
    watch: {
      userCountries(countries) {
        this.setCountries(countries);
      },
      filter(nextVal) {
        this.filterCountries(nextVal);
      }
    },
    created() {
      this.setCountries(this.userCountries);
    },
    methods: {
      toggle() {
        this.isOn = !this.isOn;
      },
      getTriggerClass() {
        return {
          active: this.isOn,
        };
      },
      getItemClass(lang) {
        return {
          'active-item': lang.isSelected,
          'menu-item': true
        };
      },
      updateItems: (items, path) => items.map(item => {
        const selectedPaths = item.paths.filter(itemPath => path.indexOf(itemPath) > -1);

        return {
          ...item,
          isSelected: selectedPaths.length > 0
        };
      }),
      redirect(path) {
        this.$router.push(path);
      },
      setCountries(countries) {
        const { code, name } = this.selectedCountry;
        let query = { code, name };
        let nextCountries = countries.map(country => ({
          ...country,
          isSelected: country.code === code
        }));

        this.countries = nextCountries;
        this.allCountries = nextCountries;

        const hasSelectedCountry = this.countries.filter((c) => c.isSelected).length === 1;

        if (this.countries.length > 0 && !hasSelectedCountry) {
          nextCountries = this.countries.map((country, index) => ({
            ...country,
            isSelected: index === 0
          }));

          this.countries = nextCountries;
          this.allCountries = nextCountries;

          query = this.countries.find((c) => c.isSelected);
          return this.$store.dispatch('config/setCountry', query);
        }
      },
      setCountry({ code, name }) {
        const nextCountries = this.countries.map(country => ({
          ...country,
          isSelected: country.code === code
        }));

        this.countries = nextCountries;
        this.allCountries = nextCountries;

        return this.$store.dispatch('config/setCountry', { code, name });
      },
      updateFilter({ key }) {
        if (key === 'Backspace') {
          this.filter = this.filter.substring(0, this.filter.length - 1);
        } else if (/[a-zA-Z]/.test(key)) {
          this.filter = this.filter + key;
        }
      },
      filterCountries() {
        const { allCountries, filter } = this;

        this.countries = filter !== ''
          ? allCountries.filter(({ name }) => name.toLowerCase().indexOf(filter) > -1)
          : allCountries;
      }
    }
  };
</script>

<style lang="stylus">
  @import '../assets/stylus/theme.styl';

  [data-component="countries-menu"] {
    display: inline-block;
    position: relative;

    .trigger.select-item {
      height: 33px;
      border-radius: 4px;
      letter-spacing: 0.16px;
      font-weight: 500;
      line-height: 24px;
      padding-right: 6px;
      margin: 0;

      @media (max-width: $grid-breakpoints.xs) {
        height: 24px;
      }

      &:not(.active) {
        .icon-chevron {
          transform: rotate(0deg);
          transition: all 0.15s ease-in-out;
        }
      }

      &.active {
        background-color: $colors.primary;

        .icon-chevron {
          transform: rotate(180deg);
          transition: all 0.15s ease-in-out;
        }
      }

      .v-icon {
        font-size: 20px;
        transition: all 0.15s ease-in-out !important;
      }

      .icon-avatar {
        margin: 0 6px 0 0;
      }

      .icon-chevron {
        margin: 0 0 0 10px;
      }

      @media (max-width: $grid-breakpoints.md) {
        font-size: 12px;
      }
    }
  }

  .countries-menu-content {
    .menu-item {
      border-bottom: 1px solid $colors.grey.lighten-3;

      &:last-child {
        border: none;
      }

      .v-icon {
        font-size: 20px;
        margin: 0 0 0 14px;
      }
    }

    .v-list__tile__title {
      color: $colors.secondary;
    }

    .active-item {
      background-color: $colors.grey.lighten-1;

      .v-list__tile__title {
        color: $colors.shades.white;
      }

      .v-icon {
        color: $colors.shades.white;
      }
    }
  }
</style>
